import os
from os.path import join
import sys
from time import time

from pycompss.api.task import task
from pycompss.api.binary import binary
from pycompss.api.constraint import constraint
from pycompss.api.mpi import mpi
from pycompss.api.api import compss_wait_on
from pycompss.api.api import compss_barrier
from pycompss.api.parameter import *


# in the container
# date
# mpirun --allow-run-as-root --mca btl_vader_single_copy_mechanism none -n 2  fesom.x
# date

# in MN4
# mpirun -n 2  ./fesom.x

# TODO: check how to properly configure the JSON file, also which version of COMPSs supports these new decorators
#@Software(esm.json)
#enqueue_compss -t --qos=debug  --log_level=debug  --job_name=fesom2 --max_tasks_per_node=2 --exec_time=20 --num_nodes=1 --pythonpath=$PWD  esm_simulation.py

# working decorator in MN4
# @mpi(binary="/home/bsc32/bsc32044/fesom_hecuba/work_pi/fesom.x", runner="mpirun", processes="2", working_dir="/home/bsc32/bsc32044/fesom_hecuba/work_pi", fail_by_exit_value=True)
@mpi(binary="fesom.x", runner="srun", processes="2", working_dir="." , fail_by_exit_value=True)
@task()
def esm_simulation():
    pass

if __name__ == "__main__":
    from pycompss.api.api import compss_open
    print("Running FESOM2 - pi dataset")
    esm_simulation()
